// Coding
//------------------------------------------------------------------------------
function CharCoding(char, code) {
	this.char = char;
	this.code = code;
}

function Coding(name, charCodings, delimiter = '') {
	this.name = name;
	this.charCodings = charCodings;
	this.delimiter = delimiter;
}

Coding.prototype.encodeChar = function(char) {
	let coding = this.charCodings.find(coding => coding.char === char);
	return coding ? coding.code : '';
}

Coding.prototype.encode = function(text) {
	return text.toUpperCase().split('').map(char => this.encodeChar(char)).join(this.delimiter);
}

// Morse Coding
//------------------------------------------------------------------------------
const morseAlphabet =
	'A=.-;B=-...;C=-.-.;D=-..;E=.;F=..-.;G=--.;H=....;I=..;J=.---;K=-.-;L=.-..;M=--;' +
	'N=-.;O=---;P=.--.;Q=--.-;R=.-.;S=...;T=-;U=..-;V=...-;W=.--;X=-..-;Y=-.--;Z=--..';
let morseCodings = morseAlphabet.split(';').map(coding => new CharCoding(...coding.split('=')));
let morseCoding = new Coding('Morse', morseCodings, '/');

// Hex Coding
//------------------------------------------------------------------------------
const alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ ';
let hexCodings = alphabet.split('')
	.map(char => new CharCoding(char, char.charCodeAt(0).toString(16)));
let hexCoding = new Coding('Hex', hexCodings, ' ');

// Caesar Coding
//------------------------------------------------------------------------------
let caesarCodings = alphabet.split('')
	.map(char => new CharCoding(char, alphabet[(alphabet.indexOf(char) + 1) % alphabet.length]));
let caesarCoding = new Coding('Caesar', caesarCodings);

module.exports = { morseCoding, hexCoding, caesarCoding };
